.386
.model flat, STDCALL
option casemap :none

include	\masm32\include\windows.inc
include	\masm32\include\masm32.inc 
include	\masm32\include\kernel32.inc
include	\masm32\include\user32.inc
include	\masm32\include\comctl32.inc
include	\masm32\include\comdlg32.inc
include	\masm32\include\advapi32.inc
include	\masm32\include\oleaut32.inc
include \masm32\include\debug.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\advapi32.lib
includelib \masm32\lib\debug.lib

include \masm32\macros\macros.asm

LVSORT struct
	handle		dd	?
	direction	dd	?
	column		dd	?
	Gtype		dd	?
LVSORT ENDS

HDRIMAGE struct
	dwItem		DD	?
	dwDir		DD	?
HDRIMAGE ENDS

.data
	AppName		db "listView Sort", 0
	ListIndex	dd 0
	hdimage		HDRIMAGE <-1,0>
	icc	 	DQ 3FFF00000008h

.data?
	hInstance	dd	?
	HeapHandle	dd	?
	lblbff		dd	?
	hHeader		DD	?
	hList		dd	?

	hdi		HDITEM {?}
	Glvsort		LVSORT	<?>
	buffer		DB	256 DUP (?)

.const
	IDC_EDIT	equ	1002
	IDC_LIST	equ	1003
	IDC_CLR		equ	1004
	IDC_IST		equ	1005
	IDD_ICON	equ	109
	IDD_DIALOG	equ	110

.code

AddItem proc item:DWORD, subitem:DWORD, tdata:DWORD
	LOCAL newitem:LV_ITEM
	LOCAL lstmsg:DWORD

	mov newitem.imask, LVIF_TEXT
	m2m newitem.iItem, item
	m2m newitem.iSubItem, subitem
	m2m newitem.pszText, tdata
	invoke lstrlen, tdata
	inc eax
	mov newitem.cchTextMax, eax
	.IF subitem == 0h
		mov lstmsg, LVM_INSERTITEM
	.ELSE
		mov lstmsg, LVM_SETITEM
	.ENDIF
	invoke SendMessage, hList, lstmsg, 0h, addr newitem
	invoke SendMessage, hList, LVM_ENSUREVISIBLE, item, FALSE
	ret
AddItem endp

AddItemInt proc item:DWORD, subitem:DWORD, tdword:DWORD
	
	invoke wsprintf, lblbff, CTXT('%i'), tdword
	invoke AddItem, item, subitem, lblbff
	ret
AddItemInt endp

AddColumn proc tdata:DWORD, cnum:DWORD, wth:DWORD
	LOCAL ncol:LV_COLUMN
	
	m2m ncol.lx, wth
	m2m ncol.pszText, tdata
	invoke lstrlen, tdata
	inc eax
	mov ncol.cchTextMax, eax
	mov ncol.imask, LVCF_TEXT
	.IF ncol.lx != 0h
		or ncol.imask, LVCF_WIDTH
	.ENDIF
	invoke SendMessage, hList, LVM_INSERTCOLUMN, cnum, addr ncol
	ret
AddColumn endp

InitListView proc
	
	invoke	AddColumn, CTXT('Index'), 0d, 70d
	invoke	AddColumn, CTXT('Test_Text'), 1d, 340d
	invoke	SendMessage,hList,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_FULLROWSELECT + LVS_EX_GRIDLINES,LVS_EX_GRIDLINES + LVS_EX_FULLROWSELECT 
	
	invoke	ImageList_LoadImage,hInstance,11000,16,0,08000FFh,IMAGE_BITMAP,LR_CREATEDIBSECTION
	invoke	SendMessage,hHeader,HDM_SETIMAGELIST,0,eax
	mov	hdi._mask,HDI_FORMAT + HDI_IMAGE
	mov	hdi.fmt,HDF_IMAGE + HDF_STRING + HDF_BITMAP_ON_RIGHT
	mov	hdi.iImage,0

	invoke	SendMessage,hHeader,HDM_GETITEMCOUNT,0,0
	dec	eax
	mov	edi,eax
@@:
	invoke	SendMessage,hHeader,HDM_SETITEM,edi,ADDR hdi
	dec	edi
	jns	@B

	ret
	ret
InitListView endp

LVSortProc proc uses ebx edi esi lParam1,lParam2,lParamSort
	LOCAL ItemData1:LV_ITEM
	LOCAL ItemData2:LV_ITEM
	LOCAL Tbuff1[256]:BYTE
	LOCAL Tbuff2[256]:BYTE

	; lParamSort pointer to LVSORT structure
	mov	edi,lParamSort
	mov	ebx,[edi.LVSORT].column
	mov	esi,[edi.LVSORT].handle

	mov	eax,lParam1
	mov	ItemData1.iItem,eax
	mov	ItemData1.iSubItem,ebx
	mov	ItemData1.imask,LVIF_TEXT + LVIF_PARAM 
	lea	eax,Tbuff1
	mov	ItemData1.pszText,eax
	mov	ItemData1.cchTextMax,255
	invoke	SendMessage,esi,LVM_GETITEM,0,ADDR ItemData1

	mov	eax,lParam2
	mov	ItemData2.iItem,eax
	mov	ItemData2.iSubItem,ebx
	mov	ItemData2.imask,LVIF_TEXT + LVIF_PARAM
	lea	eax,Tbuff2
	mov	ItemData2.pszText,eax
	mov	ItemData2.cchTextMax,255
	invoke	SendMessage,esi,LVM_GETITEM,0,addr ItemData2

	cmp	[edi.LVSORT].Gtype,1
	mov	edi,[edi.LVSORT].direction
	jb	P1
	ja	I1
	
	; String sort
	invoke	lstrcmpi,addr Tbuff1,addr Tbuff2
	or	edi,edi
	jz	@f
	neg	eax
@@:
	ret

	; lParam sort
P1:
	mov	eax,ItemData2.lParam
	mov	ecx,ItemData1.lParam
	cmp	ecx,eax
	jae	@f
	mov	eax,-1
	jmp	P2
@@:
	jne	@F
	mov	eax,0
	jmp	P2
@@:
	mov	eax,1
P2:
	or	edi,edi
	jz	@F
	neg	eax
@@:
	ret

	; Image sort
I1:
	mov	eax,ItemData2.iImage
	mov	ecx,ItemData1.iImage
	cmp	ecx,eax
	jae	@F
	mov	eax,-1
	jmp	@I2
@@:
	jne	@F
	mov	eax,0
	jmp	@I2
@@:
	mov	eax,1
@I2:
	or	edi,edi
	jz	@F
	neg	eax
@@:
	ret

LVSortProc endp

DialogWin proc uses ebx esi edi hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	LOCAL lvhi:LVHITTESTINFO
	LOCAL lvi:LV_ITEM
	LOCAL szBuf[256]:BYTE
	
	mov	eax,uMsg
	.IF eax== WM_INITDIALOG

		invoke	LoadIcon, hInstance, IDD_ICON
		invoke	SendMessage, hWnd, WM_SETICON, ICON_SMALL or ICON_BIG, eax
		invoke	GetDlgItem, hWnd, IDC_LIST
		mov	hList, eax
		
		invoke	SendMessage,hList,LVM_GETHEADER,0,0
		mov	hHeader,eax
		invoke	InitListView
		
	.elseif eax== WM_COMMAND
		mov	eax,wParam
		.if eax== IDC_IST   
			invoke	RtlZeroMemory, addr szBuf, 256
			invoke	GetDlgItemText,hWnd,IDC_EDIT,addr szBuf,256
			mov	eax,ListIndex
			inc	eax
			invoke	AddItemInt, ListIndex, 0d, eax        
			invoke	AddItem, ListIndex, 1d, addr szBuf
			inc	ListIndex
		.elseif eax== IDC_CLR   
			invoke	SendMessage, hList, LVM_DELETEALLITEMS, 0h, 0h
			xor	eax,eax
			mov	ListIndex,eax
		.endif
	.elseif eax==WM_NOTIFY					; listview feedback
		push	edi
		mov	edi,lParam
		cmp	[edi.NMHDR].code,HDN_ITEMCLICK
		jnz	@HDN_ITEMCHANGED
		mov	eax,HDI_IMAGE
		or	eax,HDI_FORMAT
		mov	hdi._mask,eax
		invoke	SendMessage,hHeader,HDM_GETITEM,[edi.NMHEADER].iItem,ADDR hdi
		test	hdi.fmt,HDF_IMAGE
		jz	@WMN_DONE
			
		mov	eax,hdimage.dwItem
		or	eax,eax
		js	@H1
		
		cmp	eax,[edi.NMHEADER].iItem
		je	@H2
		
		mov	ecx,0
		invoke	SendMessage,hHeader,HDM_SETITEM,hdimage.dwItem,ADDR hdi
		mov	hdimage.dwDir,1
		mov	ecx,1
		jmp	@H1
@H2:
		mov	ecx,hdimage.dwDir
		test	ecx,1
		je	@F
		
		mov	ecx,2
		jmp	@H1
@@:
		mov	ecx,1
@H1:
		mov	eax,[edi.NMHEADER].iItem
		mov	hdimage.dwItem,eax
		mov	hdi.iImage,ecx
		mov	hdimage.dwDir,ecx
		; D[hdi.iItem] = the header item that was clicked
		; D[hdi.iImage] = the current image
		; set to 0 = no arrow, 1 = down arrow, 2 = up arrow
		invoke	SendMessage,hHeader,HDM_SETITEM,[edi.NMHEADER].iItem,ADDR hdi

		; Sort the column by text based on the direction arrow
		mov	eax,hList
		mov	Glvsort.handle,eax ; Handle of the listview to sort
		mov	eax,hdimage.dwDir
		shr	eax,1
		mov	Glvsort.direction,eax ; FALSE = ascending , TRUE = descending
		mov	eax,[edi.NMHEADER].iItem
		mov	Glvsort.column,eax ; Column to sort
		mov	Glvsort.Gtype,1 ; 0 = param, 1 = string, 2 = image index
		invoke	SendMessage, hList, LVM_SORTITEMSEX, offset Glvsort, offset LVSortProc
		jmp	@WMN_DONE

@HDN_ITEMCHANGED:
		cmp	[edi.NMHDR].code,HDN_ITEMCHANGED
		jnz	@NMCLICK
		; Redraw the listview when header resized
		invoke	InvalidateRect,hList,NULL,NULL
		invoke	UpdateWindow,hList
		jmp	@WMN_DONE

@NMCLICK:
		cmp	[edi.NMHDR].code,NM_CLICK
		jnz	@WMN_DONE
		invoke	GetMessagePos
		movzx	ecx,ax
		mov	lvhi.pt.x,ecx
		shr	eax,16
		movzx	ecx,ax
		mov	lvhi.pt.y,ecx
		invoke	ScreenToClient,hList,ADDR lvhi.pt
		invoke	SendMessage,hList,LVM_SUBITEMHITTEST,0,ADDR lvhi
		; returns the column and item that was clicked in lvhi
		mov	eax,lvhi.iItem
		mov	lvi.iItem,eax
		mov	lvi.iSubItem,0
		mov	lvi.cchTextMax,255
		mov	lvi.pszText,OFFSET buffer
		invoke	SendMessage,hList,LVM_GETITEMTEXT,lvhi.iItem,ADDR lvi
@WMN_DONE:
		pop edi
	.elseif eax == WM_CLOSE
		invoke EndDialog, hWnd, 0h
	.else
		mov eax,FALSE
		ret
	.endif
	mov eax,TRUE
	ret

DialogWin endp

start:
	invoke	GetModuleHandle, 0h
	mov	hInstance, eax
	invoke	GetProcessHeap
	mov	HeapHandle,eax

	invoke	HeapAlloc,HeapHandle,HEAP_ZERO_MEMORY,65535d
	mov	lblbff, eax
	invoke	InitCommonControlsEx,OFFSET icc
	invoke	DialogBoxParam, hInstance, IDD_DIALOG, 0h, addr DialogWin, 0h
	invoke	HeapFree,HeapHandle,HEAP_ZERO_MEMORY,lblbff 
	invoke	ExitProcess,NULL


end start
